package org.eclipse.jdt.internal.compiler.ast;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.eclipse.jdt.internal.compiler.ASTVisitor;
import org.eclipse.jdt.internal.compiler.ast.ASTNode;
import org.eclipse.jdt.internal.compiler.ast.BinaryExpression;
import org.eclipse.jdt.internal.compiler.ast.Expression;
import org.eclipse.jdt.internal.compiler.codegen.BranchLabel;
import org.eclipse.jdt.internal.compiler.codegen.CodeStream;
import org.eclipse.jdt.internal.compiler.flow.FlowContext;
import org.eclipse.jdt.internal.compiler.flow.FlowInfo;
import org.eclipse.jdt.internal.compiler.flow.UnconditionalFlowInfo;
import org.eclipse.jdt.internal.compiler.impl.Constant;
import org.eclipse.jdt.internal.compiler.lookup.Binding;
import org.eclipse.jdt.internal.compiler.lookup.BlockScope;
import org.eclipse.jdt.internal.compiler.lookup.Scope;
import org.eclipse.jdt.internal.compiler.lookup.TypeBinding;

public class OR_OR_Expression extends BinaryExpression {
  int rightInitStateIndex = -1;
  
  int mergedInitStateIndex = -1;
  
  public OR_OR_Expression(Expression left, Expression right, int operator) {
    super(left, right, operator);
  }
  
  public FlowInfo analyseCode(BlockScope currentScope, FlowContext flowContext, FlowInfo flowInfo) {
    Constant cst = this.left.optimizedBooleanConstant();
    boolean isLeftOptimizedTrue = (cst != Constant.NotAConstant && cst.booleanValue());
    boolean isLeftOptimizedFalse = (cst != Constant.NotAConstant && !cst.booleanValue());
    if (isLeftOptimizedFalse) {
      UnconditionalFlowInfo unconditionalFlowInfo1 = this.left.analyseCode(currentScope, flowContext, flowInfo).unconditionalInits();
      flowContext.expireNullCheckedFieldInfo();
      FlowInfo flowInfo2 = this.right.analyseCode(currentScope, flowContext, (FlowInfo)unconditionalFlowInfo1);
      flowContext.expireNullCheckedFieldInfo();
      this.mergedInitStateIndex = 
        currentScope.methodScope().recordInitializationStates(flowInfo2);
      return flowInfo2;
    } 
    FlowInfo leftInfo = this.left.analyseCode(currentScope, flowContext, flowInfo);
    if ((flowContext.tagBits & 0x4) == 0)
      flowContext.expireNullCheckedFieldInfo(); 
    UnconditionalFlowInfo unconditionalFlowInfo = leftInfo.initsWhenFalse().unconditionalCopy();
    this.rightInitStateIndex = 
      currentScope.methodScope().recordInitializationStates((FlowInfo)unconditionalFlowInfo);
    int previousMode = unconditionalFlowInfo.reachMode();
    if (isLeftOptimizedTrue && (
      unconditionalFlowInfo.reachMode() & 0x3) == 0) {
      currentScope.problemReporter().fakeReachable((ASTNode)this.right);
      unconditionalFlowInfo.setReachMode(1);
    } 
    FlowInfo flowInfo1 = this.right.analyseCode(currentScope, flowContext, (FlowInfo)unconditionalFlowInfo);
    if ((flowContext.tagBits & 0x4) == 0)
      flowContext.expireNullCheckedFieldInfo(); 
    this.left.checkNPEbyUnboxing(currentScope, flowContext, flowInfo);
    this.right.checkNPEbyUnboxing(currentScope, flowContext, leftInfo.initsWhenFalse());
    FlowInfo leftInfoWhenTrueForMerging = leftInfo.initsWhenTrue().unconditionalCopy().addPotentialInitializationsFrom((FlowInfo)flowInfo1.unconditionalInitsWithoutSideEffect());
    FlowInfo mergedInfo = FlowInfo.conditional(
        
        (FlowInfo)leftInfoWhenTrueForMerging.unconditionalInits().mergedWith(
          flowInfo1.safeInitsWhenTrue().setReachMode(previousMode).unconditionalInits()), 
        flowInfo1.initsWhenFalse());
    this.mergedInitStateIndex = 
      currentScope.methodScope().recordInitializationStates(mergedInfo);
    return mergedInfo;
  }
  
  public void generateCode(BlockScope currentScope, CodeStream codeStream, boolean valueRequired) {
    // Byte code:
    //   0: aload_2
    //   1: getfield position : I
    //   4: istore #4
    //   6: aload_0
    //   7: getfield constant : Lorg/eclipse/jdt/internal/compiler/impl/Constant;
    //   10: getstatic org/eclipse/jdt/internal/compiler/impl/Constant.NotAConstant : Lorg/eclipse/jdt/internal/compiler/impl/Constant;
    //   13: if_acmpeq -> 43
    //   16: iload_3
    //   17: ifeq -> 32
    //   20: aload_2
    //   21: aload_0
    //   22: getfield constant : Lorg/eclipse/jdt/internal/compiler/impl/Constant;
    //   25: aload_0
    //   26: getfield implicitConversion : I
    //   29: invokevirtual generateConstant : (Lorg/eclipse/jdt/internal/compiler/impl/Constant;I)V
    //   32: aload_2
    //   33: iload #4
    //   35: aload_0
    //   36: getfield sourceStart : I
    //   39: invokevirtual recordPositionsFrom : (II)V
    //   42: return
    //   43: aload_0
    //   44: getfield right : Lorg/eclipse/jdt/internal/compiler/ast/Expression;
    //   47: getfield constant : Lorg/eclipse/jdt/internal/compiler/impl/Constant;
    //   50: astore #5
    //   52: aload #5
    //   54: getstatic org/eclipse/jdt/internal/compiler/impl/Constant.NotAConstant : Lorg/eclipse/jdt/internal/compiler/impl/Constant;
    //   57: if_acmpeq -> 135
    //   60: aload #5
    //   62: invokevirtual booleanValue : ()Z
    //   65: ifeq -> 89
    //   68: aload_0
    //   69: getfield left : Lorg/eclipse/jdt/internal/compiler/ast/Expression;
    //   72: aload_1
    //   73: aload_2
    //   74: iconst_0
    //   75: invokevirtual generateCode : (Lorg/eclipse/jdt/internal/compiler/lookup/BlockScope;Lorg/eclipse/jdt/internal/compiler/codegen/CodeStream;Z)V
    //   78: iload_3
    //   79: ifeq -> 99
    //   82: aload_2
    //   83: invokevirtual iconst_1 : ()V
    //   86: goto -> 99
    //   89: aload_0
    //   90: getfield left : Lorg/eclipse/jdt/internal/compiler/ast/Expression;
    //   93: aload_1
    //   94: aload_2
    //   95: iload_3
    //   96: invokevirtual generateCode : (Lorg/eclipse/jdt/internal/compiler/lookup/BlockScope;Lorg/eclipse/jdt/internal/compiler/codegen/CodeStream;Z)V
    //   99: aload_0
    //   100: getfield mergedInitStateIndex : I
    //   103: iconst_m1
    //   104: if_icmpeq -> 116
    //   107: aload_2
    //   108: aload_1
    //   109: aload_0
    //   110: getfield mergedInitStateIndex : I
    //   113: invokevirtual removeNotDefinitelyAssignedVariables : (Lorg/eclipse/jdt/internal/compiler/lookup/Scope;I)V
    //   116: aload_2
    //   117: aload_0
    //   118: getfield implicitConversion : I
    //   121: invokevirtual generateImplicitConversion : (I)V
    //   124: aload_2
    //   125: iload #4
    //   127: aload_0
    //   128: getfield sourceStart : I
    //   131: invokevirtual recordPositionsFrom : (II)V
    //   134: return
    //   135: new org/eclipse/jdt/internal/compiler/codegen/BranchLabel
    //   138: dup
    //   139: aload_2
    //   140: invokespecial <init> : (Lorg/eclipse/jdt/internal/compiler/codegen/CodeStream;)V
    //   143: astore #6
    //   145: aload_0
    //   146: getfield left : Lorg/eclipse/jdt/internal/compiler/ast/Expression;
    //   149: invokevirtual optimizedBooleanConstant : ()Lorg/eclipse/jdt/internal/compiler/impl/Constant;
    //   152: astore #5
    //   154: aload #5
    //   156: getstatic org/eclipse/jdt/internal/compiler/impl/Constant.NotAConstant : Lorg/eclipse/jdt/internal/compiler/impl/Constant;
    //   159: if_acmpeq -> 166
    //   162: iconst_1
    //   163: goto -> 167
    //   166: iconst_0
    //   167: istore #8
    //   169: iload #8
    //   171: ifeq -> 186
    //   174: aload #5
    //   176: invokevirtual booleanValue : ()Z
    //   179: ifeq -> 186
    //   182: iconst_1
    //   183: goto -> 187
    //   186: iconst_0
    //   187: istore #9
    //   189: aload_0
    //   190: getfield right : Lorg/eclipse/jdt/internal/compiler/ast/Expression;
    //   193: invokevirtual optimizedBooleanConstant : ()Lorg/eclipse/jdt/internal/compiler/impl/Constant;
    //   196: astore #5
    //   198: aload #5
    //   200: getstatic org/eclipse/jdt/internal/compiler/impl/Constant.NotAConstant : Lorg/eclipse/jdt/internal/compiler/impl/Constant;
    //   203: if_acmpeq -> 210
    //   206: iconst_1
    //   207: goto -> 211
    //   210: iconst_0
    //   211: istore #10
    //   213: iload #10
    //   215: ifeq -> 230
    //   218: aload #5
    //   220: invokevirtual booleanValue : ()Z
    //   223: ifeq -> 230
    //   226: iconst_1
    //   227: goto -> 231
    //   230: iconst_0
    //   231: istore #11
    //   233: iload #8
    //   235: ifeq -> 256
    //   238: aload_0
    //   239: getfield left : Lorg/eclipse/jdt/internal/compiler/ast/Expression;
    //   242: aload_1
    //   243: aload_2
    //   244: iconst_0
    //   245: invokevirtual generateCode : (Lorg/eclipse/jdt/internal/compiler/lookup/BlockScope;Lorg/eclipse/jdt/internal/compiler/codegen/CodeStream;Z)V
    //   248: iload #9
    //   250: ifeq -> 269
    //   253: goto -> 317
    //   256: aload_0
    //   257: getfield left : Lorg/eclipse/jdt/internal/compiler/ast/Expression;
    //   260: aload_1
    //   261: aload_2
    //   262: aload #6
    //   264: aconst_null
    //   265: iconst_1
    //   266: invokevirtual generateOptimizedBoolean : (Lorg/eclipse/jdt/internal/compiler/lookup/BlockScope;Lorg/eclipse/jdt/internal/compiler/codegen/CodeStream;Lorg/eclipse/jdt/internal/compiler/codegen/BranchLabel;Lorg/eclipse/jdt/internal/compiler/codegen/BranchLabel;Z)V
    //   269: aload_0
    //   270: getfield rightInitStateIndex : I
    //   273: iconst_m1
    //   274: if_icmpeq -> 286
    //   277: aload_2
    //   278: aload_1
    //   279: aload_0
    //   280: getfield rightInitStateIndex : I
    //   283: invokevirtual addDefinitelyAssignedVariables : (Lorg/eclipse/jdt/internal/compiler/lookup/Scope;I)V
    //   286: iload #10
    //   288: ifeq -> 304
    //   291: aload_0
    //   292: getfield right : Lorg/eclipse/jdt/internal/compiler/ast/Expression;
    //   295: aload_1
    //   296: aload_2
    //   297: iconst_0
    //   298: invokevirtual generateCode : (Lorg/eclipse/jdt/internal/compiler/lookup/BlockScope;Lorg/eclipse/jdt/internal/compiler/codegen/CodeStream;Z)V
    //   301: goto -> 317
    //   304: aload_0
    //   305: getfield right : Lorg/eclipse/jdt/internal/compiler/ast/Expression;
    //   308: aload_1
    //   309: aload_2
    //   310: aload #6
    //   312: aconst_null
    //   313: iload_3
    //   314: invokevirtual generateOptimizedBoolean : (Lorg/eclipse/jdt/internal/compiler/lookup/BlockScope;Lorg/eclipse/jdt/internal/compiler/codegen/CodeStream;Lorg/eclipse/jdt/internal/compiler/codegen/BranchLabel;Lorg/eclipse/jdt/internal/compiler/codegen/BranchLabel;Z)V
    //   317: aload_0
    //   318: getfield mergedInitStateIndex : I
    //   321: iconst_m1
    //   322: if_icmpeq -> 334
    //   325: aload_2
    //   326: aload_1
    //   327: aload_0
    //   328: getfield mergedInitStateIndex : I
    //   331: invokevirtual removeNotDefinitelyAssignedVariables : (Lorg/eclipse/jdt/internal/compiler/lookup/Scope;I)V
    //   334: iload_3
    //   335: ifeq -> 514
    //   338: iload #8
    //   340: ifeq -> 370
    //   343: iload #9
    //   345: ifeq -> 370
    //   348: aload_2
    //   349: invokevirtual iconst_1 : ()V
    //   352: aload_2
    //   353: aload_2
    //   354: getfield position : I
    //   357: aload_0
    //   358: getfield left : Lorg/eclipse/jdt/internal/compiler/ast/Expression;
    //   361: getfield sourceEnd : I
    //   364: invokevirtual recordPositionsFrom : (II)V
    //   367: goto -> 491
    //   370: iload #10
    //   372: ifeq -> 402
    //   375: iload #11
    //   377: ifeq -> 402
    //   380: aload_2
    //   381: invokevirtual iconst_1 : ()V
    //   384: aload_2
    //   385: aload_2
    //   386: getfield position : I
    //   389: aload_0
    //   390: getfield left : Lorg/eclipse/jdt/internal/compiler/ast/Expression;
    //   393: getfield sourceEnd : I
    //   396: invokevirtual recordPositionsFrom : (II)V
    //   399: goto -> 406
    //   402: aload_2
    //   403: invokevirtual iconst_0 : ()V
    //   406: aload #6
    //   408: invokevirtual forwardReferenceCount : ()I
    //   411: ifle -> 486
    //   414: aload_0
    //   415: getfield bits : I
    //   418: bipush #16
    //   420: iand
    //   421: ifeq -> 449
    //   424: aload_2
    //   425: aload_0
    //   426: getfield implicitConversion : I
    //   429: invokevirtual generateImplicitConversion : (I)V
    //   432: aload_2
    //   433: aload_0
    //   434: invokevirtual generateReturnBytecode : (Lorg/eclipse/jdt/internal/compiler/ast/Expression;)V
    //   437: aload #6
    //   439: invokevirtual place : ()V
    //   442: aload_2
    //   443: invokevirtual iconst_1 : ()V
    //   446: goto -> 491
    //   449: aload_2
    //   450: new org/eclipse/jdt/internal/compiler/codegen/BranchLabel
    //   453: dup
    //   454: aload_2
    //   455: invokespecial <init> : (Lorg/eclipse/jdt/internal/compiler/codegen/CodeStream;)V
    //   458: dup
    //   459: astore #7
    //   461: invokevirtual goto_ : (Lorg/eclipse/jdt/internal/compiler/codegen/BranchLabel;)V
    //   464: aload_2
    //   465: iconst_1
    //   466: invokevirtual decrStackSize : (I)V
    //   469: aload #6
    //   471: invokevirtual place : ()V
    //   474: aload_2
    //   475: invokevirtual iconst_1 : ()V
    //   478: aload #7
    //   480: invokevirtual place : ()V
    //   483: goto -> 491
    //   486: aload #6
    //   488: invokevirtual place : ()V
    //   491: aload_2
    //   492: aload_0
    //   493: getfield implicitConversion : I
    //   496: invokevirtual generateImplicitConversion : (I)V
    //   499: aload_2
    //   500: aload_2
    //   501: getfield position : I
    //   504: aload_0
    //   505: getfield sourceEnd : I
    //   508: invokevirtual recordPositionsFrom : (II)V
    //   511: goto -> 519
    //   514: aload #6
    //   516: invokevirtual place : ()V
    //   519: return
    // Line number table:
    //   Java source line number -> byte code offset
    //   #96	-> 0
    //   #97	-> 6
    //   #99	-> 16
    //   #100	-> 20
    //   #101	-> 32
    //   #102	-> 42
    //   #104	-> 43
    //   #105	-> 52
    //   #107	-> 60
    //   #108	-> 68
    //   #109	-> 78
    //   #110	-> 86
    //   #112	-> 89
    //   #114	-> 99
    //   #115	-> 107
    //   #117	-> 116
    //   #118	-> 124
    //   #119	-> 134
    //   #122	-> 135
    //   #123	-> 145
    //   #124	-> 154
    //   #125	-> 169
    //   #127	-> 189
    //   #128	-> 198
    //   #129	-> 213
    //   #132	-> 233
    //   #133	-> 238
    //   #134	-> 248
    //   #135	-> 253
    //   #138	-> 256
    //   #141	-> 269
    //   #142	-> 277
    //   #144	-> 286
    //   #145	-> 291
    //   #146	-> 301
    //   #147	-> 304
    //   #150	-> 317
    //   #151	-> 325
    //   #158	-> 334
    //   #159	-> 338
    //   #160	-> 348
    //   #161	-> 352
    //   #162	-> 367
    //   #163	-> 370
    //   #164	-> 380
    //   #165	-> 384
    //   #166	-> 399
    //   #167	-> 402
    //   #169	-> 406
    //   #170	-> 414
    //   #171	-> 424
    //   #172	-> 432
    //   #173	-> 437
    //   #174	-> 442
    //   #175	-> 446
    //   #176	-> 449
    //   #177	-> 464
    //   #178	-> 469
    //   #179	-> 474
    //   #180	-> 478
    //   #182	-> 483
    //   #183	-> 486
    //   #186	-> 491
    //   #187	-> 499
    //   #188	-> 511
    //   #189	-> 514
    //   #191	-> 519
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	520	0	this	Lorg/eclipse/jdt/internal/compiler/ast/OR_OR_Expression;
    //   0	520	1	currentScope	Lorg/eclipse/jdt/internal/compiler/lookup/BlockScope;
    //   0	520	2	codeStream	Lorg/eclipse/jdt/internal/compiler/codegen/CodeStream;
    //   0	520	3	valueRequired	Z
    //   6	514	4	pc	I
    //   52	468	5	cst	Lorg/eclipse/jdt/internal/compiler/impl/Constant;
    //   145	375	6	trueLabel	Lorg/eclipse/jdt/internal/compiler/codegen/BranchLabel;
    //   461	22	7	endLabel	Lorg/eclipse/jdt/internal/compiler/codegen/BranchLabel;
    //   169	351	8	leftIsConst	Z
    //   189	331	9	leftIsTrue	Z
    //   213	307	10	rightIsConst	Z
    //   233	287	11	rightIsTrue	Z
  }
  
  public void generateOptimizedBoolean(BlockScope currentScope, CodeStream codeStream, BranchLabel trueLabel, BranchLabel falseLabel, boolean valueRequired) {
    if (this.constant != Constant.NotAConstant) {
      super.generateOptimizedBoolean(currentScope, codeStream, trueLabel, falseLabel, valueRequired);
      return;
    } 
    Constant cst = this.right.constant;
    if (cst != Constant.NotAConstant && !cst.booleanValue()) {
      int pc = codeStream.position;
      this.left.generateOptimizedBoolean(currentScope, codeStream, trueLabel, falseLabel, valueRequired);
      if (this.mergedInitStateIndex != -1)
        codeStream.removeNotDefinitelyAssignedVariables((Scope)currentScope, this.mergedInitStateIndex); 
      codeStream.recordPositionsFrom(pc, this.sourceStart);
      return;
    } 
    cst = this.left.optimizedBooleanConstant();
    boolean leftIsConst = (cst != Constant.NotAConstant);
    boolean leftIsTrue = (leftIsConst && cst.booleanValue());
    cst = this.right.optimizedBooleanConstant();
    boolean rightIsConst = (cst != Constant.NotAConstant);
    boolean rightIsTrue = (rightIsConst && cst.booleanValue());
    if (falseLabel == null) {
      if (trueLabel != null) {
        this.left.generateOptimizedBoolean(currentScope, codeStream, trueLabel, null, !leftIsConst);
        if (leftIsTrue) {
          if (valueRequired)
            codeStream.goto_(trueLabel); 
          codeStream.recordPositionsFrom(codeStream.position, this.left.sourceEnd);
        } else {
          if (this.rightInitStateIndex != -1)
            codeStream.addDefinitelyAssignedVariables((Scope)currentScope, this.rightInitStateIndex); 
          this.right.generateOptimizedBoolean(currentScope, codeStream, trueLabel, null, (valueRequired && !rightIsConst));
          if (valueRequired && rightIsTrue) {
            codeStream.goto_(trueLabel);
            codeStream.recordPositionsFrom(codeStream.position, this.sourceEnd);
          } 
        } 
      } 
    } else if (trueLabel == null) {
      BranchLabel internalTrueLabel = new BranchLabel(codeStream);
      this.left.generateOptimizedBoolean(currentScope, codeStream, internalTrueLabel, null, !leftIsConst);
      if (leftIsTrue) {
        internalTrueLabel.place();
      } else {
        if (this.rightInitStateIndex != -1)
          codeStream
            .addDefinitelyAssignedVariables((Scope)currentScope, this.rightInitStateIndex); 
        this.right.generateOptimizedBoolean(currentScope, codeStream, null, falseLabel, (valueRequired && !rightIsConst));
        int pc = codeStream.position;
        if (valueRequired && rightIsConst && !rightIsTrue) {
          codeStream.goto_(falseLabel);
          codeStream.recordPositionsFrom(pc, this.sourceEnd);
        } 
        internalTrueLabel.place();
      } 
    } 
    if (this.mergedInitStateIndex != -1)
      codeStream.removeNotDefinitelyAssignedVariables((Scope)currentScope, this.mergedInitStateIndex); 
  }
  
  public boolean isCompactableOperation() {
    return false;
  }
  
  public TypeBinding resolveType(BlockScope scope) {
    TypeBinding result = super.resolveType(scope);
    Binding leftDirect = Expression.getDirectBinding(this.left);
    if (leftDirect != null && leftDirect == Expression.getDirectBinding(this.right) && 
      !(this.right instanceof org.eclipse.jdt.internal.compiler.ast.Assignment))
      scope.problemReporter().comparingIdenticalExpressions((Expression)this); 
    return result;
  }
  
  public void traverse(ASTVisitor visitor, BlockScope scope) {
    if (visitor.visit(this, scope)) {
      this.left.traverse(visitor, scope);
      this.right.traverse(visitor, scope);
    } 
    visitor.endVisit(this, scope);
  }
}
